import openai
import json
from termcolor import colored

# define your OpenAI API key
# openai.api_key = "YOUR_API_KEY"

model = "gpt-3.5-turbo-16k-0613"
# model = "gpt-4-0613"

def summarize_text(text, model):
    response = openai.ChatCompletion.create(
        model = model,
        messages = [
            {"role": "user", "content": f"summarize: {text}"},
        ],
        # stream = True,
        functions = [
            {
                "name": "summarize_document",
                "description": "Summarizes a document by returning a summary",
                "parameters": {
                    "type": "object",
                    "properties": {
                        "summary": {
                            "type": "string",
                            "description": "a short summary of the document."
                        }
                    },
                    "required": ["summary"]
                }
            }
        ],
        function_call = {"name": "summarize_document"} # can be "auto" or "none"
    )

    print(colored(response, "green"))
    response_message = response["choices"][0]["message"]

    if response_message.get("function_call"):
        function_name = response_message["function_call"]["name"]
        function_args = json.loads(response_message["function_call"]["arguments"])

    print(colored(response_message, "yellow"))
    print(colored(function_args["summary"], "blue"))

    

# read the contents of sample.txt
with open('sample.txt', 'r', encoding="utf-8", errors="ignore") as file:
    sample = file.read().replace('\n', '')

summarize_text(sample, model)