import openai
import json
from termcolor import colored

# define your OpenAI API key
# openai.api_key = "YOUR_API_KEY"

model = "gpt-3.5-turbo-16k-0613"
# model = "gpt-4-0613"

def summarize_text(text, model):
    response = openai.ChatCompletion.create(
        model = model,
        messages = [
            {"role": "user", "content": f"summarize: {text}"},
        ],
        stream = True,
        functions = [
            {
                "name": "summarize_document",
                "description": "Summarizes a document by returning a summary",
                "parameters": {
                    "type": "object",
                    "properties": {
                        "summary": {
                            "type": "string",
                            "description": "a short summary of the document."
                        }
                    },
                    "required": ["summary"]
                }
            }
        ],
        function_call = {"name": "summarize_document"} # can be "auto" or "none"
    )

    responses = ''
    for chunk in response:
        # print(chunk)
        if chunk["choices"][0]["delta"].get("function_call"):
            chunk = chunk["choices"][0]["delta"]
            # print(chunk)
            summary = chunk["function_call"]["arguments"]
            responses += summary
            print(summary, end='', flush=True)

    summary = json.loads(responses)["summary"]

    return summary

# read the contents of sample.txt
with open('sample.txt', 'r', encoding="utf-8", errors="ignore") as file:
    sample = file.read().replace('\n', '')

print(colored(summarize_text(sample, model), "blue"))